Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module FAD16H

    '
    ' Device status (Return value)
    '
    Public Const FAD16H_OK As Integer = 0
    Public Const FAD16H_INVALID_HANDLE As Integer = 1
    Public Const FAD16H_DEVICE_NOT_FOUND As Integer = 2
    Public Const FAD16H_DEVICE_NOT_OPENED As Integer = 3
    Public Const FAD16H_OTHER_ERROR As Integer = 4
    Public Const FAD16H_COMMUNICATION_ERROR As Integer = 5
    Public Const FAD16H_INVALID_PARAMETER As Integer = 6
    Public Const FAD16H_MEMORY_ERROR As Integer = 7

    '
    ' Device Type
    '
    Public Const FAD16H_DEVICE_TYPE_S As Byte = 0	' FAD-16HS
    Public Const FAD16H_DEVICE_TYPE_T As Byte = 1	' FAD-16HT

    '
    ' Sampling Rate
    '
    Public Const FAD16H_SAMPLING_RATE_2MSPS As Integer = 10
    Public Const FAD16H_SAMPLING_RATE_1MSPS As Integer = 20
    Public Const FAD16H_SAMPLING_RATE_500KSPS As Integer = 40
    Public Const FAD16H_SAMPLING_RATE_200KSPS As Integer = 100
    Public Const FAD16H_SAMPLING_RATE_100KSPS As Integer = 200
    Public Const FAD16H_SAMPLING_RATE_50KSPS As Integer = 400
    Public Const FAD16H_SAMPLING_RATE_20KSPS As Integer = 1000
    Public Const FAD16H_SAMPLING_RATE_10KSPS As Integer = 2000
    Public Const FAD16H_SAMPLING_RATE_5KSPS As Integer = 4000
    Public Const FAD16H_SAMPLING_RATE_2KSPS As Integer = 10000
    Public Const FAD16H_SAMPLING_RATE_1KSPS As Integer = 20000
    Public Const FAD16H_SAMPLING_RATE_500SPS As Integer = 40000
    Public Const FAD16H_SAMPLING_RATE_200SPS As Integer = 100000
    Public Const FAD16H_SAMPLING_RATE_100SPS As Integer = 200000
    Public Const FAD16H_SAMPLING_RATE_50SPS As Integer = 400000
    Public Const FAD16H_SAMPLING_RATE_20SPS As Integer = 1000000
    Public Const FAD16H_SAMPLING_RATE_10SPS As Integer = 2000000

    '
    ' Sampling Mode
    '
    Public Const FAD16H_SAMPLING_MODE_INTERNAL As Byte = 0			' Internal clock
    Public Const FAD16H_SAMPLING_MODE_EXTERNAL_EDGE_ON As Byte = 1	' External clock edge on
    Public Const FAD16H_SAMPLING_MODE_EXTERNAL_EDGE_OFF As Byte = 2	' External clock edge off

    '
    ' Trigger Type
    '
    Public Const FAD16H_TRIGGER_TYPE_LEVEL_H As Byte = 0
    Public Const FAD16H_TRIGGER_TYPE_LEVEL_L As Byte = 1
    Public Const FAD16H_TRIGGER_TYPE_SLOPE_RISING As Byte = 2
    Public Const FAD16H_TRIGGER_TYPE_SLOPE_FALLING As Byte = 3
    Public Const FAD16H_TRIGGER_TYPE_EDGE_ON As Byte = 4
    Public Const FAD16H_TRIGGER_TYPE_EDGE_OFF As Byte = 5

    '
    ' Device Functions
    '
    Public Declare Function FAD16H_GetNumberOfDevices Lib "FAD16H.dll" (ByRef Number As Integer) As Integer
    Public Declare Function FAD16H_GetSerialNumber Lib "FAD16H.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function FAD16H_Open Lib "FAD16H.dll" (ByRef ID As Byte) As Integer
    Public Declare Function FAD16H_OpenBySerialNumber Lib "FAD16H.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function FAD16H_Close Lib "FAD16H.dll" (ByVal ID As Byte) As Integer
    Public Declare Function FAD16H_GetDeviceType Lib "FAD16H.dll" (ByVal ID As Byte, ByRef DeviceType As Byte) As Integer

    '
    ' A/D Functions
    '
    Public Declare Function FAD16H_Start Lib "FAD16H.dll" (ByVal ID As Byte, ByVal SamplingMode As Byte, ByVal SamplingRate As Integer, ByVal SamplingCount As Integer) As Integer
    Public Declare Function FAD16H_TriggerStart Lib "FAD16H.dll" (ByVal ID As Byte, ByVal SamplingMode As Byte, ByVal SamplingRate As Integer, ByVal PostTriggerCount As Integer, ByVal TriggerType As Byte, ByVal TriggerThreshold As Double, ByVal TriggerOccurs As Integer) As Integer
    Public Declare Function FAD16H_Stop Lib "FAD16H.dll" (ByVal ID As Byte) As Integer
    Public Declare Function FAD16H_GetStatus Lib "FAD16H.dll" (ByVal ID As Byte, ByRef MemoryStatus As Byte, ByRef TriggerStatus As Byte, ByRef ExtTriggerState As Byte, ByRef ExtClockState As Byte) As Integer
    Public Declare Function FAD16H_GetMemoryWriteCount Lib "FAD16H.dll" (ByVal ID As Byte, ByRef Count As Integer) As Integer
    Public Declare Function FAD16H_GetTriggerAddr Lib "FAD16H.dll" (ByVal ID As Byte, ByRef Addr As Integer) As Integer
    Public Declare Function FAD16H_ReadMemory Lib "FAD16H.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal Data As Object, ByVal Addr As Integer, ByVal Count As Integer) As Integer

End Module
