Attribute VB_Name = "FAD16H"
Option Explicit

'
' Device status (Return value)
'
Public Const FAD16H_OK As Long = 0
Public Const FAD16H_INVALID_HANDLE As Long = 1
Public Const FAD16H_DEVICE_NOT_FOUND As Long = 2
Public Const FAD16H_DEVICE_NOT_OPENED As Long = 3
Public Const FAD16H_OTHER_ERROR As Long = 4
Public Const FAD16H_COMMUNICATION_ERROR As Long = 5
Public Const FAD16H_INVALID_PARAMETER As Long = 6
Public Const FAD16H_MEMORY_ERROR As Long = 7

'
' Device Type
'
Public Const FAD16H_DEVICE_TYPE_S As Byte = 0	' FAD-16HS
Public Const FAD16H_DEVICE_TYPE_T As Byte = 1	' FAD-16HT

'
' Sampling Rate
'
Public Const FAD16H_SAMPLING_RATE_2MSPS As Long = 10
Public Const FAD16H_SAMPLING_RATE_1MSPS As Long = 20
Public Const FAD16H_SAMPLING_RATE_500KSPS As Long = 40
Public Const FAD16H_SAMPLING_RATE_200KSPS As Long = 100
Public Const FAD16H_SAMPLING_RATE_100KSPS As Long = 200
Public Const FAD16H_SAMPLING_RATE_50KSPS As Long = 400
Public Const FAD16H_SAMPLING_RATE_20KSPS As Long = 1000
Public Const FAD16H_SAMPLING_RATE_10KSPS As Long = 2000
Public Const FAD16H_SAMPLING_RATE_5KSPS As Long = 4000
Public Const FAD16H_SAMPLING_RATE_2KSPS As Long = 10000
Public Const FAD16H_SAMPLING_RATE_1KSPS As Long = 20000
Public Const FAD16H_SAMPLING_RATE_500SPS As Long = 40000
Public Const FAD16H_SAMPLING_RATE_200SPS As Long = 100000
Public Const FAD16H_SAMPLING_RATE_100SPS As Long = 200000
Public Const FAD16H_SAMPLING_RATE_50SPS As Long = 400000
Public Const FAD16H_SAMPLING_RATE_20SPS As Long = 1000000
Public Const FAD16H_SAMPLING_RATE_10SPS As Long = 2000000

'
' Sampling Mode
'
Public Const FAD16H_SAMPLING_MODE_INTERNAL As Byte = 0			' Internal clock
Public Const FAD16H_SAMPLING_MODE_EXTERNAL_EDGE_ON As Byte = 1	' External clock edge on
Public Const FAD16H_SAMPLING_MODE_EXTERNAL_EDGE_OFF As Byte = 2	' External clock edge off

'
' Trigger Type
'
Public Const FAD16H_TRIGGER_TYPE_LEVEL_H As Byte = 0
Public Const FAD16H_TRIGGER_TYPE_LEVEL_L As Byte = 1
Public Const FAD16H_TRIGGER_TYPE_SLOPE_RISING As Byte = 2
Public Const FAD16H_TRIGGER_TYPE_SLOPE_FALLING As Byte = 3
Public Const FAD16H_TRIGGER_TYPE_EDGE_ON As Byte = 4
Public Const FAD16H_TRIGGER_TYPE_EDGE_OFF As Byte = 5

'
' Device Functions
'
Public Declare Function FAD16H_GetNumberOfDevices Lib "FAD16H.dll" (ByRef Number As Long) As Long
Public Declare Function FAD16H_GetSerialNumber Lib "FAD16H.dll" (ByVal Index As Long, ByRef SerialNumber As Long) As Long
Public Declare Function FAD16H_Open Lib "FAD16H.dll" (ByRef ID As Byte) As Long
Public Declare Function FAD16H_OpenBySerialNumber Lib "FAD16H.dll" (ByVal SerialNumber As Long, ByRef ID As Byte) As Long
Public Declare Function FAD16H_Close Lib "FAD16H.dll" (ByVal ID As Byte) As Long
Public Declare Function FAD16H_GetDeviceType Lib "FAD16H.dll" (ByVal ID As Byte, ByRef DeviceType As Byte) As Long

'
' A/D Functions
'
Public Declare Function FAD16H_Start Lib "FAD16H.dll" (ByVal ID As Byte, ByVal SamplingMode As Byte, ByVal SamplingRate As Long, ByVal SamplingCount As Long) As Long
Public Declare Function FAD16H_TriggerStart Lib "FAD16H.dll" (ByVal ID As Byte, ByVal SamplingMode As Byte, ByVal SamplingRate As Long, ByVal PostTriggerCount As Long, ByVal TriggerType As Byte, ByVal TriggerThreshold As Double, ByVal TriggerOccurs As Long) As Long
Public Declare Function FAD16H_Stop Lib "FAD16H.dll" (ByVal ID As Byte) As Long
Public Declare Function FAD16H_GetStatus Lib "FAD16H.dll" (ByVal ID As Byte, ByRef MemoryStatus As Byte, ByRef TriggerStatus As Byte, ByRef ExtTriggerState As Byte, ByRef ExtClockState As Byte) As Long
Public Declare Function FAD16H_GetMemoryWriteCount Lib "FAD16H.dll" (ByVal ID As Byte, ByRef Count As Long) As Long
Public Declare Function FAD16H_GetTriggerAddr Lib "FAD16H.dll" (ByVal ID As Byte, ByRef Addr As Long) As Long
Public Declare Function FAD16H_ReadMemory Lib "FAD16H.dll" (ByVal ID As Byte, ByRef Data As Double, ByVal Addr As Long, ByVal Count As Long) As Long
